-- Added:
-- Leveling messages
-- Login message (guild and popup)
-- Death counter.
-- Thank you message for resurrection

-- To be added:
-- Config
-- 


local EventFrame = CreateFrame("Frame") -- Login Thingy (not checking if loaded)
EventFrame:RegisterEvent("PLAYER_LOGIN")
EventFrame:SetScript("OnEvent", function(self,event,...)
	if IsInGuild("player") then
		if GuildMessagesValue == true then
			SendChatMessage(""..GuildMessagesText.."" , "GUILD")
		else
			if Reloading == true then
				Reloading = false
				GuildMessagesValue = true
			else
			GuildMessagesValue = false
			end
		end
	else
	end
	message("Greetings " .. UnitName("Player").. "! Nice to see you! Last time I checked, you were in level " .. UnitLevel("Player") .. ". Hope today's WoWing is fruitfull and fun!")
end)

local LoadedFrame = CreateFrame("Frame")
LoadedFrame:RegisterEvent("ADDON_LOADED")
function LoadedFrame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "TheBrohmanMultiaddon" then	
		if GuildMessagesValue then
			GuildMessagesValue = GuildMessagesValue
		elseif GuildMessagesValue == false then
			GuildMessagesValue = false
		else
			GuildMessagesValue = true
		end
		
		if fishing then
			fishing = fishing
		else
			fishing = 0;
		end
		
		if GuildMessagesText then
			GuildMessagesText = GuildMessagesText
		else
			GuildMessagesText = "Hello there, lovely people!"
		end
		
		if RessMsg then
			RessMsg = RessMsg
		else
			RessMsg = true
		end
		
		if CharacterDead == nil then
			CharacterDead = 0
		end
		
		if OverallDead == nil then
			OverallDead = 0
		end
		
		if DeathMessages then
			DeathMessages = DeathMessages
		else
			DeathMessages = true
		end
	end
end
LoadedFrame:SetScript("OnEvent", LoadedFrame.OnEvent);

local ressFrame = CreateFrame("Frame")
ressFrame:RegisterEvent("RESURRECT_REQUEST")
local function eventHandler(self, event, from)
	if RessMsg then
		if event == "RESURRECT_REQUEST" then
			AcceptResurrect();
			SendChatMessage("Thank you for resurrecting me!", "WHISPER", nil, from);
		end
	end
end
ressFrame:SetScript("OnEvent", eventHandler)

local oldReloadUI = ReloadUI;
function ReloadUI()
	Reloading = true
    GuildMessagesValue = false
    oldReloadUI();
end

local dieFrame = CreateFrame("Frame")
dieFrame:RegisterEvent("PLAYER_DEAD")
dieFrame:SetScript("OnEvent", function(self, ...)
	OverallDead = OverallDead + 1
	CharacterDead = CharacterDead + 1
	if DeathMessages then
		if CharacterDead == 1 then
			print("You just died for the first time on this character!")
			print("Total deaths overall: |cff00ccff"..OverallDead.."|r!")
		else
			print("Amount of deaths on this character: |cff00ccff"..CharacterDead.."|r!")
			print("Total deaths overall: |cff00ccff"..OverallDead.."|r!")
		end
	end
end)

local lvlFrame = CreateFrame("Frame")
lvlFrame:RegisterEvent("PLAYER_LEVEL_UP")
lvlFrame:SetScript("OnEvent",
	function(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 = ...
	print("Congratulations on reaching level " .. arg1 .. ", " .. UnitName("Player") .. "!")
	if IsInGuild("player") then
		if (arg1 % 5) == 0 and (arg1 >= 10) then
			SendChatMessage("DING level " .. arg1 .. "! :D", "GUILD")
		end
	else
	end
end)

SLASH_MAINCOMMANDS1, SLASH_MAINCOMMANDS2 = '/tbm', '/tbma';
function CommandHandler(input)
	local command, text = input:match("^(%S*)%s*(.-)$");
	
	if command:lower() == 'toggle' then
		if text == nil or text == '' then
			print("Wrong usage of the toggle command. Use like this: |cff00ccff/tbm toggle ress/guild/deaths|r!")
		elseif text:lower() == 'ress' then
			if RessMsg then
				RessMsg = false
				print("Resurrection message&accept has been toggled |cff00ccffoff|r!")
			else
				RessMsg = true
				print("Resurrection message&accept has been toggled |cff00ccffon|r!")
			end
		elseif text:lower() == 'guild' then
			if GuildMessagesValue then
				GuildMessagesValue = false
				print("Guild login-message has been toggled |cff00ccffoff|r!")
			else
				GuildMessagesValue = true
				print("Guild login-message has been toggled |cff00ccffon|r!")
			end
		elseif text:lower() == 'deaths' or text:lower() == 'death' then
			if DeathMessages then
				DeathMessages = false
				print("Death Counter messages has been toggled |cff00ccffoff|r!")
			else
				DeathMessages = true
				print("Death Counter messages has been toggled |cff00ccffon|r!")
			end
		else
			print("Wrong usage of the toggle command. Use like this: |cff00ccff/tbm toggle ress/guild/deaths|r!")
		end
	elseif command:lower() == 'guild' then
		if text == nil or text == '' then
			print("Current login message: |cff00ccff"..GuildMessagesText.."|r.")
		elseif text:lower() == 'reset' then
			print("Guild Login message has been reset to: |cff00ccff".."Hello there, lovely people!")
			GuildMessagesText = "Hello there, lovely people!"
		else
			print("Guild-logon message changed to: |cff00ccff"..text.."|r.")
			GuildMessagesText = text
		end
	elseif command:lower() == 'deaths' then
		print("Amount of deaths on this character: |cff00ccff"..CharacterDead.."|r!")
		print("Total deaths overall: |cff00ccff"..OverallDead.."|r!")
	elseif command:lower() == 'meha' or command:lower() == 'mehriaa' then
			print("|cff00ccffNever forgotten... Sleep well my dear princess <3|r")
	elseif command:lower() == 'fishing' then
		if text:lower() == 'reset' then
		print("Fishing clicks has been reset")
		fishing = 0;
		elseif text:lower() == 'show' then
		print("Fishing clicks: "..fishing.."!")
		else
		fishing = fishing + 1;
		end
	elseif command:lower() == 'reload' or command:lower() == 'rl' then
		ReloadUI();
	else
		print("List of commands:")
		print("/tbm toggle ress/guild/deaths- |cff00ccffToggle the different modules!|r")
		print("/tbm - |cff00ccffShows all the available commands!|r")
		print("/tbm guild (reset)- |cff00ccffShows/Sets(/resets) the current guild message!")
		print("/tbm deaths - |cff00ccffShows you how many times you have died!")
		print("/tbm fishing (show/reset) - |cff00ccffUsed to keep track of fishing throws. Put /tbm fishing in a macro with /cast Fishing")
		print("/tbm reload/rl - |cff00ccffReloads the User Interface, but doesn't send the guild login message. (No")
		print("|cff00ccffneed to use this if you have guild messages turned off. This will toggle guild messages on after reload)")
	end
end
SlashCmdList["MAINCOMMANDS"] = CommandHandler; -- Also a valid assignment strategy